#include <curses.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <pthread.h>
#include <time.h>

void impTitulo();
void sombra(int x1,int y1,int x2,int y2,int color);
void cuadro(int col,int lin,int alto, int ancho);
int menu(int x,int y,int item,int ancho,char *items[]);
void intallDriver();
void contInterrup();
void reinicCont();
void setContador();
void medirVel();
void desintall();
int tomarValor();
void installGPM(int device, int protocol);
void * impInterrup(void);//func de hilo para imprimir interrupciones

pthread_t thread;

int arch;
unsigned long nroint = 0;
//---------MAIN-----------------------------------------------------------
main(int argc, char *argv[])
{
    int a,b,conf;
    int device,protocol; 
    char *menuTipo[]={"Serie","USB","PS2","Salir"};
    char *menuSerie[]={"ttyS0/COM1","ttyS1/COM2","ttyS2/COM3","Volver"};
    char *menuProtocol[]={"Microsoft","PS/2","Salir"};
    char *menuPrincipal[]={"Instalar Controlador","Obtener Contador de Interrupciones","Reiniciar Contador","Espesificar Valor al Contador","Medir Velocidad de Interrupcion","Desinstalar Controlador","Salir"};
    char *menuError[]={"Salir"};

    initscr(); //inicia libreria de curses      
    keypad(stdscr, TRUE);  
//permite mapeo del teclado
    noecho(); //saca el echo de entrada
    start_color();
    init_pair(2,4,4);
    bkgd(COLOR_PAIR(2));
    impTitulo();
    //-----ABRO EL MODULO CARGADO--------------------------
    arch = open("/dev/mouse",O_RDONLY);
    if(arch==-1){
	attrset(COLOR_PAIR(3) | A_BOLD);
	mvprintw(6,24,"Imposible acceder al dispositivo");
	a=menu(35,10,1,9,menuError);
	endwin();
	return;
    }    
    //Menu para seleccuinar dispositivo
    a=0;
    b=0;
    conf=0;
    while(a!=3)
{
	a=menu(35,10,4,10,menuTipo);
	switch(a)
{
	    case 0:
	
    		b=menu(50,10,4,15,menuSerie);
		switch(b){
		    case 0: //ttyS0 ;
			    device = 0;
			    a=3;
			    conf=1;
			    break;
		    case 1: //ttyS1 ;
			    device = 1;
			    a=3;
			    conf=1;
			    break;
		    case 2: //ttyS2 ;
			    a=3;
			    conf=1;
			    device = 2;
			    break;
		}
		break;
	    case 1:
 //comando para cargar USB
		device = 3;
		a=3;
		conf=1;
		break;
	    case 2:
 //comando para cargar PS2
		device = 4;
		a=3;
		conf=1;
		break;
	}	
    }
    //tapo cuados viejos
    sombra(33,9,70,18,4);

    //selecciono protocolo
    if(conf==1){
	conf=0;
	a=0;
	a=menu(35,10,3,12,menuProtocol);
	switch(a)
{
	    case 0: 
		protocol = 0; 
		conf=1;
		break;
	    case 1:
		protocol = 1;
		conf=1;
		break;
	}
    }
    //tapo cuados viejos
    sombra(33,9,70,18,4);
    
    //instalo gpm
    if(conf==1)
	installGPM(device,protocol);
    
    //menu principal
    if(conf==1){
	a=0;
	while(a!=6)
{
	    //refresh();
	    a=menu(20,8,7,40,menuPrincipal);
	    switch(a)
{
		case 0:
	
    		    //instalar controlador 
		    intallDriver();
		    
break;
		case 1:
		    //mostrar contador de interrup
    		    contInterrup();
		    break;
		case 2:
    		    //reiniciar contador
		    reinicCont();
		    break;
		case 3:
		    //especificar valor al contador
		    setContador();
		    break;
		case 4:
		    //medir velocidad
		    medirVel();
		    break;
		case 5:
		    //desinstalar
		    desintall();
		    break;
	    }	
	}
    }
    if(conf==1) { system("/usr/sbin/gpm -k");}
    if(arch){ close(arch); }
    endwin();
}

//-------Imprime menu en pantalla-----------------------
int menu(int x,int y,int item,int ancho,char *items[])
{
   int tecla=0,z,cont=0;
   init_pair(1,3,4);
   init_pair(11,7,4);
   init_pair(4,7,2);
   attron(COLOR_PAIR(11));
   cuadro(x,y-1,item+1,ancho);
   attron(COLOR_PAIR(1) | A_BOLD);
   for (z=0;z<item;z++)
        mvprintw(y+z,x+2,items[z]);
   while(tecla!='\n')
    {
 
	attron(COLOR_PAIR(4));
         mvprintw(y+cont,x+2,items[cont]);
         tecla=getch();
         attron(COLOR_PAIR(1) | A_BOLD);
         mvprintw(y+cont,x+2,items[cont]);
         if(tecla==KEY_DOWN)
             cont++;
         if(tecla==KEY_UP)
             cont--;
         if(cont<0)
             cont=0;
         if(cont>=item)
             cont=item-1;
    }
    if(cont==item-1) 
    sombra(x-2,y-1,x+13+ancho,y+item+2,4);

    return(cont);
}
//--------Sombra para tapar cuadros viejos-------
void sombra(int x1,int y1,int x2,int y2,int color)
{
  int y,x;
  init_pair(1,color,color);
  attron(COLOR_PAIR(1));
  for (y=y1;y<y2;y++)
    for (x=x1;x<x2;x++)
          mvprintw(y,x," ");
}
//--------Imprime recuadro en pantalla----------
void cuadro(int col,int lin,int alto,int ancho)
{
    int i;
    mvaddch(lin,col-1,ACS_ULCORNER);
    hline(ACS_HLINE,ancho);
    move(lin+1,col-1);
    vline(ACS_VLINE,alto);
    mvaddch(lin,col+ancho,ACS_URCORNER);
    mvaddch(lin+alto,col-1,ACS_LLCORNER);
    hline(ACS_HLINE,ancho);
    mvaddch(lin+alto,col+ancho,ACS_LRCORNER);
    move(lin+1,col+ancho);
    vline(ACS_VLINE,alto-1);
}
//---------Intala controlador gpm-----------
void installGPM(int device, int protocol) {
int nro;
switch(device){
    case 0: 
	if(protocol == 0)  //gmp para COM1
	     system("gpm -m /dev/ttyS0 -t bare");
	else system("gpm -m /dev/ttyS0 -t ps2");
	ioctl(arch,6,4);
	break;
    case 1:
	if(protocol == 0) //gmp para COM2
	     system("gpm -m /dev/ttyS1 -t bare");
	else system("gpm -m /dev/ttyS1 -t ps2");
	ioctl(arch,6,3);
	break;
    case 2:
	if(protocol == 0)  //gmp para COM3
	     system("gpm -m /dev/ttyS2 -t bare");
	else system("gpm -m /dev/ttyS2 -t ps2");
	ioctl(arch,6,4);
	break;
    case 3:
	if(protocol == 0) // gpm para USB
	     system("gpm -m /dev/imput/mice -t bare");
	else system("gpm -m /dev/imput/mice -t ps2");
	cuadro(25,20,2,30);
	mvprintw(21,30,"Introdusca IRQ => ");
	nro = tomarValor(); 
	ioctl(arch,6,nro);
	sombra(24,19,60,24,4);
	break;
    case 4:
	if(protocol == 0)//gpm para ps2 
	     system("gpm -m /dev/psaux -t bare");
	else system("gpm -m /dev/psaux -t ps2");
	ioctl(arch,6,12);
	break;
    }
}
//--------------------------------------------------
void intallDriver(){
    int res;
    init_module();
    res = ioctl(arch,0,0);//COMANDO PARA INSTALR CONTOLADOR
    //Tapo mensaje de sistema
    clear();
    impTitulo();
    //***********************
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(25,20,2,30);
    if(res == 1)
	mvprintw(21,30,"Controlador Intalado");
    else
	mvprintw(21,28,"Controlador Ya Intalado");
    
    getch();
    sombra(24,19,60,24,4);
}
//----------------------------------------------------
void contInterrup(){
    int tecla = 0;
    int aux;
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(20,18,3,40);
    mvprintw(19,21,"Interrupciones => ");
    mvprintw(20,21,"Precione Cualquier Tecla Para Salir");
    //Creo un thread para mostrar en pantalla
    pthread_create(&thread, NULL,(void*)&impInterrup, 0);
    getch();
    pthread_cancel(thread);
    sombra(19,17,62,24,4);
}
//----------------------------------------------------
void reinicCont(){
    ioctl(arch,2,0);//COMANDO PARA REINICIAR CONTADOR
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(25,20,2,30);
    mvprintw(21,29,"Controlador Reiniciado");
    getch();
    sombra(24,19,60,24,4);
}
//---------------------------------------------------
void setContador(){
    noecho();
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(25,20,2,30);
    mvprintw(21,30,"Valor del Contador => ");
    nroint=tomarValor();
    ioctl(arch,3,nroint);//COMANDO PARA SETEAR VALOR AL CONTADOR CON "valor"
    sombra(24,19,60,24,4);
    noecho();
}
//-------------------------------------------------
void medirVel(){
    int time,diam,dient,interrup;
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(11,18,6,58);
    mvprintw(19,12,"Tiempo a calcular (seg) => ");
    time=tomarValor();
    time=time*1000;
    mvprintw(20,12,"Diametro de la rueda (cm) => ");
    diam=tomarValor();
    mvprintw(21,12,"Cantidad de dientes => ");
    dient=tomarValor();
    mvprintw(22,12,"Precione un boton y mueva la rueda del mouse.");
    getch();
    mvprintw(23,12,"Calculando Velocidad...");
    interrup = ioctl(arch,5,time);
    diam = (((3.14*diam)/dient)*interrup)/time;
    printw("%dcm x segundo",diam);
    getch();    
    sombra(10,10,70,50,4);
}
//-----------------------------------------------------
void desintall(){
    int res;
    res = ioctl(arch,1,0);//COMANDO PARA DESISTALAR CONTOLADOR
    init_pair(1,7,4);
    attrset(COLOR_PAIR(1) | A_BOLD);
    cuadro(25,20,2,30);
    if(res == 1)
	mvprintw(21,28,"Controlador Desinstalado");
    else
	mvprintw(21,30,"No Existe Controlador");
    getch();
    sombra(24,19,60,24,4);
}
//------------------------------------------------------
int tomarValor(){
    int x, nro;
    nro = 0;
    do {
	x = 0;
	x = getch();
	printw("%c",x);
	if ((x>=48)&&(x<= 57)){
	    nro = nro * 10 + (x - 48);
	}
    }
    while((x != 10) && (nro < 100000));
    return nro;
}
//------------------------------------------------------
void impTitulo(){
    init_pair(2,4,4);
    init_pair(3,7,4);
    attron(COLOR_PAIR(3) | A_BOLD);
    cuadro(14,3,3,51);
    attrset(COLOR_PAIR(2) | A_BOLD);
    mvprintw(0,35,"/\\     /\\");
    mvprintw(1,35,"  \\\\w//");
    mvprintw(2,35," _|O O|_");
    mvprintw(3,29,"o000");
    mvprintw(3,35,"(___o___)");
    mvprintw(3,46,"000o");
    mvprintw(4,38,"U U");
    mvprintw(6,28,"()()()");
    mvprintw(6,45,"()()()");
    attron(COLOR_PAIR(3) | A_BOLD);
    mvprintw(5,23,"MANEJO DE INTERRUPCIONES DE MOUSE");
}
//----------------------------------------------------------
void * impInterrup(void){
    int aux;
    while(1){
	aux = ioctl(arch,4,NULL);
	move(19,40);	
	printw("%d",aux);
	refresh();
    }
}
//----------------------------------------------------------